searchData={"items":[{"type":"module","title":"Defectoscope.Builders.Common","doc":"Provides common utility functions to help report builders","ref":"Defectoscope.Builders.Common.html"},{"type":"function","title":"Defectoscope.Builders.Common.format_kind/1","doc":"Determines the kind of error based on the reason","ref":"Defectoscope.Builders.Common.html#format_kind/1"},{"type":"function","title":"Defectoscope.Builders.Common.format_stacktrace/1","doc":"Formats a stacktrace into a list of strings","ref":"Defectoscope.Builders.Common.html#format_stacktrace/1"},{"type":"module","title":"Defectoscope.Builders.LoggerReport","doc":"Logger report builder","ref":"Defectoscope.Builders.LoggerReport.html"},{"type":"function","title":"Defectoscope.Builders.LoggerReport.build/1","doc":"Builds a new report from a log event","ref":"Defectoscope.Builders.LoggerReport.html#build/1"},{"type":"type","title":"Defectoscope.Builders.LoggerReport.params/0","doc":"","ref":"Defectoscope.Builders.LoggerReport.html#t:params/0"},{"type":"module","title":"Defectoscope.Builders.ObanReport","doc":"Oban report builder","ref":"Defectoscope.Builders.ObanReport.html"},{"type":"function","title":"Defectoscope.Builders.ObanReport.build/1","doc":"Builds a new report based on an exception event","ref":"Defectoscope.Builders.ObanReport.html#build/1"},{"type":"type","title":"Defectoscope.Builders.ObanReport.params/0","doc":"","ref":"Defectoscope.Builders.ObanReport.html#t:params/0"},{"type":"module","title":"Defectoscope.Builders.PlugReport","doc":"Plug report builder","ref":"Defectoscope.Builders.PlugReport.html"},{"type":"function","title":"Defectoscope.Builders.PlugReport.build/1","doc":"Builds a report from a plug error","ref":"Defectoscope.Builders.PlugReport.html#build/1"},{"type":"type","title":"Defectoscope.Builders.PlugReport.params/0","doc":"","ref":"Defectoscope.Builders.PlugReport.html#t:params/0"},{"type":"behaviour","title":"Defectoscope.Builders.ReportBuilder","doc":"Defines the behaviour for building reports","ref":"Defectoscope.Builders.ReportBuilder.html"},{"type":"callback","title":"Defectoscope.Builders.ReportBuilder.build/1","doc":"Build a new report","ref":"Defectoscope.Builders.ReportBuilder.html#c:build/1"},{"type":"function","title":"Defectoscope.Builders.ReportBuilder.build!/2","doc":"Build a new report from a report builder","ref":"Defectoscope.Builders.ReportBuilder.html#build!/2"},{"type":"module","title":"Defectoscope.Config","doc":"Provides configuration for Defectoscope","ref":"Defectoscope.Config.html"},{"type":"function","title":"Defectoscope.Config.app_key/0","doc":"Returns the application key","ref":"Defectoscope.Config.html#app_key/0"},{"type":"function","title":"Defectoscope.Config.debug_mode_enabled?/0","doc":"Returns whether debug mode is enabled","ref":"Defectoscope.Config.html#debug_mode_enabled?/0"},{"type":"function","title":"Defectoscope.Config.enabled?/0","doc":"Returns whether Defectoscope is enabled or disabled","ref":"Defectoscope.Config.html#enabled?/0"},{"type":"function","title":"Defectoscope.Config.endpoint_url/0","doc":"Returns the backend endpoint url","ref":"Defectoscope.Config.html#endpoint_url/0"},{"type":"function","title":"Defectoscope.Config.req_options/0","doc":"Returns Req request options","ref":"Defectoscope.Config.html#req_options/0"},{"type":"function","title":"Defectoscope.Config.validate_config!/0","doc":"Validates Defectoscope configuration","ref":"Defectoscope.Config.html#validate_config!/0"},{"type":"module","title":"Defectoscope.Forwarder","doc":"Forwards incidents to the backend server","ref":"Defectoscope.Forwarder.html"},{"type":"function","title":"Defectoscope.Forwarder.forward/1","doc":"Forwards a list of incidents to the backend server","ref":"Defectoscope.Forwarder.html#forward/1"},{"type":"module","title":"Defectoscope.IncidentsHandler","doc":"GenServer that handles incidents and forwards them to the forwarder","ref":"Defectoscope.IncidentsHandler.html"},{"type":"function","title":"Defectoscope.IncidentsHandler.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Defectoscope.IncidentsHandler.html#child_spec/1"},{"type":"function","title":"Defectoscope.IncidentsHandler.get_forwarder_errors/0","doc":"Retrieves the last 10 errors that occurred while the forwarder was running","ref":"Defectoscope.IncidentsHandler.html#get_forwarder_errors/0"},{"type":"function","title":"Defectoscope.IncidentsHandler.get_state/0","doc":"Get the current state of the incidents handler","ref":"Defectoscope.IncidentsHandler.html#get_state/0"},{"type":"function","title":"Defectoscope.IncidentsHandler.push/1","doc":"Push an incident to the incidents handler","ref":"Defectoscope.IncidentsHandler.html#push/1"},{"type":"function","title":"Defectoscope.IncidentsHandler.reset/0","doc":"Reset the incidents handler by clearing all stored incidents","ref":"Defectoscope.IncidentsHandler.html#reset/0"},{"type":"module","title":"Defectoscope.LoggerBackend","doc":"Handles Logger error messages and pushes them to the `IncidentsHandler`","ref":"Defectoscope.LoggerBackend.html"},{"type":"module","title":"Defectoscope.ObanHandler","doc":"Handles Oban exception events and pushes them to the `IncidentsHandler`","ref":"Defectoscope.ObanHandler.html"},{"type":"function","title":"Defectoscope.ObanHandler.attach/0","doc":"Attaches the handler to Oban exception events","ref":"Defectoscope.ObanHandler.html#attach/0"},{"type":"module","title":"Defectoscope.Plug","doc":"Plug to handle exceptions and push them to the `IncidentsHandler`","ref":"Defectoscope.Plug.html"},{"type":"module","title":"Defectoscope.Report","doc":"Defines a report struct","ref":"Defectoscope.Report.html"},{"type":"function","title":"Defectoscope.Report.new/1","doc":"Creates a new report using a report builder","ref":"Defectoscope.Report.html#new/1"},{"type":"function","title":"Defectoscope.Report.new/3","doc":"Creates a new report with the specified kind, message, and stack trace","ref":"Defectoscope.Report.html#new/3"},{"type":"type","title":"Defectoscope.Report.t/0","doc":"","ref":"Defectoscope.Report.html#t:t/0"},{"type":"module","title":"Defectoscope.Utils.LoggerWrapper","doc":"Wrapper around the Logger module","ref":"Defectoscope.Utils.LoggerWrapper.html"},{"type":"function","title":"Defectoscope.Utils.LoggerWrapper.debug/1","doc":"Logs a debug message if debug mode is enabled.","ref":"Defectoscope.Utils.LoggerWrapper.html#debug/1"},{"type":"module","title":"Defectoscope.Utils.SensitiveDataFilter","doc":"Filter sensitive data from params and headers","ref":"Defectoscope.Utils.SensitiveDataFilter.html"},{"type":"function","title":"Defectoscope.Utils.SensitiveDataFilter.filter_headers/1","doc":"Filter sensitive data from headers","ref":"Defectoscope.Utils.SensitiveDataFilter.html#filter_headers/1"},{"type":"function","title":"Defectoscope.Utils.SensitiveDataFilter.filter_phoenix_params/1","doc":"Filter sensitive data from phoenix params","ref":"Defectoscope.Utils.SensitiveDataFilter.html#filter_phoenix_params/1"},{"type":"function","title":"Defectoscope.Utils.SensitiveDataFilter.filter_query_string/1","doc":"Filter sensitive data from query string","ref":"Defectoscope.Utils.SensitiveDataFilter.html#filter_query_string/1"},{"type":"extras","title":"Defectoscope","doc":"# Defectoscope\n\nDefectoscope is an error tracking and reporting tool for Elixir applications. It allows you to capture errors in your application and send them to a specified endpoint for monitoring and analysis.","ref":"readme.html"},{"type":"extras","title":"Installation - Defectoscope","doc":"The package can be installed by adding defectoscope to your list of dependencies in mix.exs:\n\n```elixir\ndef deps do\n  [\n    {:defectoscope, \"~> 0.1.0\"}\n  ]\nend\n```\n\nOnce added, run `mix deps.get` in your terminal to fetch the new dependency.","ref":"readme.html#installation"},{"type":"extras","title":"Configuration - Defectoscope","doc":"To start using Defectoscope, you need to set up the configuration with your application's API key and the endpoint where error reports will be sent. Add the following to your `config/config.exs`:\n\n```elixir\nconfig :defectoscope,\n  app_key: \"your_app_key\",\n  endpoint: \"https://your_app_endpoint\",\n  debug: true,\n  enabled: true\n```\n\nReplace \"your_app_key\" with the actual app key provided to you and \"https://your_app_endpoint\" with the URL of the error reporting endpoint.\n\nThe `debug` option is used to enable or disable debug logging.\n\nThe `enabled` option is used to enable or disable error reporting.","ref":"readme.html#configuration"},{"type":"extras","title":"Usage - Defectoscope","doc":"Integrate Defectoscope in your application by adding `Defectoscope.Plug` to your router. This will capture any errors that occur during the handling of a request and report them automatically.\n\nHere is an example of how to integrate it into a Phoenix router:\n\n```elixir\ndefmodule AppWeb.Router do\n  use AppWeb, :router\n  use Defectoscope.Plug\n\n  pipeline :browser do\n    ...\n  end\n\n  scope \"/\", AppWeb do\n    pipe_through :browser\n    ...\n  end\nend\n```\n\nFor non-Phoenix applications, you can add it directly to your Plug router:\n\n```elixir\ndefmodule AppWeb.Router do\n  use Plug.Router\n  use Defectoscope.Plug\n\n  plug :match\n  plug :dispatch\n\n  get \"/\" do\n    send_resp(conn, 200, \"Welcome\")\n  end\nend\n```\n\nNow, Defectoscope will monitor your application for any errors and report them as configured.","ref":"readme.html#usage"},{"type":"extras","title":"LICENSE","doc":"# GNU AFFERO GENERAL PUBLIC LICENSE\n\nVersion 3, 19 November 2007\n\nCopyright (C) 2007 Free Software Foundation, Inc.\n \n\nEveryone is permitted to copy and distribute verbatim copies of this\nlicense document, but changing it is not allowed.","ref":"license.html"},{"type":"extras","title":"Preamble - LICENSE","doc":"The GNU Affero General Public License is a free, copyleft license for\nsoftware and other kinds of works, specifically designed to ensure\ncooperation with the community in the case of network server software.\n\nThe licenses for most software and other practical works are designed\nto take away your freedom to share and change the works. By contrast,\nour General Public Licenses are intended to guarantee your freedom to\nshare and change all versions of a program--to make sure it remains\nfree software for all its users.\n\nWhen we speak of free software, we are referring to freedom, not\nprice. Our General Public Licenses are designed to make sure that you\nhave the freedom to distribute copies of free software (and charge for\nthem if you wish), that you receive source code or can get it if you\nwant it, that you can change the software or use pieces of it in new\nfree programs, and that you know you can do these things.\n\nDevelopers that use our General Public Licenses protect your rights\nwith two steps: (1) assert copyright on the software, and (2) offer\nyou this License which gives you legal permission to copy, distribute\nand/or modify the software.\n\nA secondary benefit of defending all users' freedom is that\nimprovements made in alternate versions of the program, if they\nreceive widespread use, become available for other developers to\nincorporate. Many developers of free software are heartened and\nencouraged by the resulting cooperation. However, in the case of\nsoftware used on network servers, this result may fail to come about.\nThe GNU General Public License permits making a modified version and\nletting the public access it on a server without ever releasing its\nsource code to the public.\n\nThe GNU Affero General Public License is designed specifically to\nensure that, in such cases, the modified source code becomes available\nto the community. It requires the operator of a network server to\nprovide the source code of the modified version running there to the\nusers of that server. Therefore, public use of a modified version, on\na publicly accessible server, gives the public access to the source\ncode of the modified version.\n\nAn older license, called the Affero General Public License and\npublished by Affero, was designed to accomplish similar goals. This is\na different license, not a version of the Affero GPL, but Affero has\nreleased a new version of the Affero GPL which permits relicensing\nunder this license.\n\nThe precise terms and conditions for copying, distribution and\nmodification follow.","ref":"license.html#preamble"},{"type":"extras","title":"TERMS AND CONDITIONS - LICENSE","doc":"","ref":"license.html#terms-and-conditions"},{"type":"extras","title":"0. Definitions. - LICENSE","doc":"\"This License\" refers to version 3 of the GNU Affero General Public\nLicense.\n\n\"Copyright\" also means copyright-like laws that apply to other kinds\nof works, such as semiconductor masks.\n\n\"The Program\" refers to any copyrightable work licensed under this\nLicense. Each licensee is addressed as \"you\". \"Licensees\" and\n\"recipients\" may be individuals or organizations.\n\nTo \"modify\" a work means to copy from or adapt all or part of the work\nin a fashion requiring copyright permission, other than the making of\nan exact copy. The resulting work is called a \"modified version\" of\nthe earlier work or a work \"based on\" the earlier work.\n\nA \"covered work\" means either the unmodified Program or a work based\non the Program.\n\nTo \"propagate\" a work means to do anything with it that, without\npermission, would make you directly or secondarily liable for\ninfringement under applicable copyright law, except executing it on a\ncomputer or modifying a private copy. Propagation includes copying,\ndistribution (with or without modification), making available to the\npublic, and in some countries other activities as well.\n\nTo \"convey\" a work means any kind of propagation that enables other\nparties to make or receive copies. Mere interaction with a user\nthrough a computer network, with no transfer of a copy, is not\nconveying.\n\nAn interactive user interface displays \"Appropriate Legal Notices\" to\nthe extent that it includes a convenient and prominently visible\nfeature that (1) displays an appropriate copyright notice, and (2)\ntells the user that there is no warranty for the work (except to the\nextent that warranties are provided), that licensees may convey the\nwork under this License, and how to view a copy of this License. If\nthe interface presents a list of user commands or options, such as a\nmenu, a prominent item in the list meets this criterion.","ref":"license.html#0-definitions"},{"type":"extras","title":"1. Source Code. - LICENSE","doc":"The \"source code\" for a work means the preferred form of the work for\nmaking modifications to it. \"Object code\" means any non-source form of\na work.\n\nA \"Standard Interface\" means an interface that either is an official\nstandard defined by a recognized standards body, or, in the case of\ninterfaces specified for a particular programming language, one that\nis widely used among developers working in that language.\n\nThe \"System Libraries\" of an executable work include anything, other\nthan the work as a whole, that (a) is included in the normal form of\npackaging a Major Component, but which is not part of that Major\nComponent, and (b) serves only to enable use of the work with that\nMajor Component, or to implement a Standard Interface for which an\nimplementation is available to the public in source code form. A\n\"Major Component\", in this context, means a major essential component\n(kernel, window system, and so on) of the specific operating system\n(if any) on which the executable work runs, or a compiler used to\nproduce the work, or an object code interpreter used to run it.\n\nThe \"Corresponding Source\" for a work in object code form means all\nthe source code needed to generate, install, and (for an executable\nwork) run the object code and to modify the work, including scripts to\ncontrol those activities. However, it does not include the work's\nSystem Libraries, or general-purpose tools or generally available free\nprograms which are used unmodified in performing those activities but\nwhich are not part of the work. For example, Corresponding Source\nincludes interface definition files associated with source files for\nthe work, and the source code for shared libraries and dynamically\nlinked subprograms that the work is specifically designed to require,\nsuch as by intimate data communication or control flow between those\nsubprograms and other parts of the work.\n\nThe Corresponding Source need not include anything that users can\nregenerate automatically from other parts of the Corresponding Source.\n\nThe Corresponding Source for a work in source code form is that same\nwork.","ref":"license.html#1-source-code"},{"type":"extras","title":"2. Basic Permissions. - LICENSE","doc":"All rights granted under this License are granted for the term of\ncopyright on the Program, and are irrevocable provided the stated\nconditions are met. This License explicitly affirms your unlimited\npermission to run the unmodified Program. The output from running a\ncovered work is covered by this License only if the output, given its\ncontent, constitutes a covered work. This License acknowledges your\nrights of fair use or other equivalent, as provided by copyright law.\n\nYou may make, run and propagate covered works that you do not convey,\nwithout conditions so long as your license otherwise remains in force.\nYou may convey covered works to others for the sole purpose of having\nthem make modifications exclusively for you, or provide you with\nfacilities for running those works, provided that you comply with the\nterms of this License in conveying all material for which you do not\ncontrol copyright. Those thus making or running the covered works for\nyou must do so exclusively on your behalf, under your direction and\ncontrol, on terms that prohibit them from making any copies of your\ncopyrighted material outside their relationship with you.\n\nConveying under any other circumstances is permitted solely under the\nconditions stated below. Sublicensing is not allowed; section 10 makes\nit unnecessary.","ref":"license.html#2-basic-permissions"},{"type":"extras","title":"3. Protecting Users' Legal Rights From Anti-Circumvention Law. - LICENSE","doc":"No covered work shall be deemed part of an effective technological\nmeasure under any applicable law fulfilling obligations under article\n11 of the WIPO copyright treaty adopted on 20 December 1996, or\nsimilar laws prohibiting or restricting circumvention of such\nmeasures.\n\nWhen you convey a covered work, you waive any legal power to forbid\ncircumvention of technological measures to the extent such\ncircumvention is effected by exercising rights under this License with\nrespect to the covered work, and you disclaim any intention to limit\noperation or modification of the work as a means of enforcing, against\nthe work's users, your or third parties' legal rights to forbid\ncircumvention of technological measures.","ref":"license.html#3-protecting-users-legal-rights-from-anti-circumvention-law"},{"type":"extras","title":"4. Conveying Verbatim Copies. - LICENSE","doc":"You may convey verbatim copies of the Program's source code as you\nreceive it, in any medium, provided that you conspicuously and\nappropriately publish on each copy an appropriate copyright notice;\nkeep intact all notices stating that this License and any\nnon-permissive terms added in accord with section 7 apply to the code;\nkeep intact all notices of the absence of any warranty; and give all\nrecipients a copy of this License along with the Program.\n\nYou may charge any price or no price for each copy that you convey,\nand you may offer support or warranty protection for a fee.","ref":"license.html#4-conveying-verbatim-copies"},{"type":"extras","title":"5. Conveying Modified Source Versions. - LICENSE","doc":"You may convey a work based on the Program, or the modifications to\nproduce it from the Program, in the form of source code under the\nterms of section 4, provided that you also meet all of these\nconditions:\n\n-   a) The work must carry prominent notices stating that you modified\n    it, and giving a relevant date.\n-   b) The work must carry prominent notices stating that it is\n    released under this License and any conditions added under\n    section 7. This requirement modifies the requirement in section 4\n    to \"keep intact all notices\".\n-   c) You must license the entire work, as a whole, under this\n    License to anyone who comes into possession of a copy. This\n    License will therefore apply, along with any applicable section 7\n    additional terms, to the whole of the work, and all its parts,\n    regardless of how they are packaged. This License gives no\n    permission to license the work in any other way, but it does not\n    invalidate such permission if you have separately received it.\n-   d) If the work has interactive user interfaces, each must display\n    Appropriate Legal Notices; however, if the Program has interactive\n    interfaces that do not display Appropriate Legal Notices, your\n    work need not make them do so.\n\nA compilation of a covered work with other separate and independent\nworks, which are not by their nature extensions of the covered work,\nand which are not combined with it such as to form a larger program,\nin or on a volume of a storage or distribution medium, is called an\n\"aggregate\" if the compilation and its resulting copyright are not\nused to limit the access or legal rights of the compilation's users\nbeyond what the individual works permit. Inclusion of a covered work\nin an aggregate does not cause this License to apply to the other\nparts of the aggregate.","ref":"license.html#5-conveying-modified-source-versions"},{"type":"extras","title":"6. Conveying Non-Source Forms. - LICENSE","doc":"You may convey a covered work in object code form under the terms of\nsections 4 and 5, provided that you also convey the machine-readable\nCorresponding Source under the terms of this License, in one of these\nways:\n\n-   a) Convey the object code in, or embodied in, a physical product\n    (including a physical distribution medium), accompanied by the\n    Corresponding Source fixed on a durable physical medium\n    customarily used for software interchange.\n-   b) Convey the object code in, or embodied in, a physical product\n    (including a physical distribution medium), accompanied by a\n    written offer, valid for at least three years and valid for as\n    long as you offer spare parts or customer support for that product\n    model, to give anyone who possesses the object code either (1) a\n    copy of the Corresponding Source for all the software in the\n    product that is covered by this License, on a durable physical\n    medium customarily used for software interchange, for a price no\n    more than your reasonable cost of physically performing this\n    conveying of source, or (2) access to copy the Corresponding\n    Source from a network server at no charge.\n-   c) Convey individual copies of the object code with a copy of the\n    written offer to provide the Corresponding Source. This\n    alternative is allowed only occasionally and noncommercially, and\n    only if you received the object code with such an offer, in accord\n    with subsection 6b.\n-   d) Convey the object code by offering access from a designated\n    place (gratis or for a charge), and offer equivalent access to the\n    Corresponding Source in the same way through the same place at no\n    further charge. You need not require recipients to copy the\n    Corresponding Source along with the object code. If the place to\n    copy the object code is a network server, the Corresponding Source\n    may be on a different server (operated by you or a third party)\n    that supports equivalent copying facilities, provided you maintain\n    clear directions next to the object code saying where to find the\n    Corresponding Source. Regardless of what server hosts the\n    Corresponding Source, you remain obligated to ensure that it is\n    available for as long as needed to satisfy these requirements.\n-   e) Convey the object code using peer-to-peer transmission,\n    provided you inform other peers where the object code and\n    Corresponding Source of the work are being offered to the general\n    public at no charge under subsection 6d.\n\nA separable portion of the object code, whose source code is excluded\nfrom the Corresponding Source as a System Library, need not be\nincluded in conveying the object code work.\n\nA \"User Product\" is either (1) a \"consumer product\", which means any\ntangible personal property which is normally used for personal,\nfamily, or household purposes, or (2) anything designed or sold for\nincorporation into a dwelling. In determining whether a product is a\nconsumer product, doubtful cases shall be resolved in favor of\ncoverage. For a particular product received by a particular user,\n\"normally used\" refers to a typical or common use of that class of\nproduct, regardless of the status of the particular user or of the way\nin which the particular user actually uses, or expects or is expected\nto use, the product. A product is a consumer product regardless of\nwhether the product has substantial commercial, industrial or\nnon-consumer uses, unless such uses represent the only significant\nmode of use of the product.\n\n\"Installation Information\" for a User Product means any methods,\nprocedures, authorization keys, or other information required to\ninstall and execute modified versions of a covered work in that User\nProduct from a modified version of its Corresponding Source. The\ninformation must suffice to ensure that the continued functioning of\nthe modified object code is in no case prevented or interfered with\nsolely because modification has been made.\n\nIf you convey an object code work under this section in, or with, or\nspecifically for use in, a User Product, and the conveying occurs as\npart of a transaction in which the right of possession and use of the\nUser Product is transferred to the recipient in perpetuity or for a\nfixed term (regardless of how the transaction is characterized), the\nCorresponding Source conveyed under this section must be accompanied\nby the Installation Information. But this requirement does not apply\nif neither you nor any third party retains the ability to install\nmodified object code on the User Product (for example, the work has\nbeen installed in ROM).\n\nThe requirement to provide Installation Information does not include a\nrequirement to continue to provide support service, warranty, or\nupdates for a work that has been modified or installed by the\nrecipient, or for the User Product in which it has been modified or\ninstalled. Access to a network may be denied when the modification\nitself materially and adversely affects the operation of the network\nor violates the rules and protocols for communication across the\nnetwork.\n\nCorresponding Source conveyed, and Installation Information provided,\nin accord with this section must be in a format that is publicly\ndocumented (and with an implementation available to the public in\nsource code form), and must require no special password or key for\nunpacking, reading or copying.","ref":"license.html#6-conveying-non-source-forms"},{"type":"extras","title":"7. Additional Terms. - LICENSE","doc":"\"Additional permissions\" are terms that supplement the terms of this\nLicense by making exceptions from one or more of its conditions.\nAdditional permissions that are applicable to the entire Program shall\nbe treated as though they were included in this License, to the extent\nthat they are valid under applicable law. If additional permissions\napply only to part of the Program, that part may be used separately\nunder those permissions, but the entire Program remains governed by\nthis License without regard to the additional permissions.\n\nWhen you convey a copy of a covered work, you may at your option\nremove any additional permissions from that copy, or from any part of\nit. (Additional permissions may be written to require their own\nremoval in certain cases when you modify the work.) You may place\nadditional permissions on material, added by you to a covered work,\nfor which you have or can give appropriate copyright permission.\n\nNotwithstanding any other provision of this License, for material you\nadd to a covered work, you may (if authorized by the copyright holders\nof that material) supplement the terms of this License with terms:\n\n-   a) Disclaiming warranty or limiting liability differently from the\n    terms of sections 15 and 16 of this License; or\n-   b) Requiring preservation of specified reasonable legal notices or\n    author attributions in that material or in the Appropriate Legal\n    Notices displayed by works containing it; or\n-   c) Prohibiting misrepresentation of the origin of that material,\n    or requiring that modified versions of such material be marked in\n    reasonable ways as different from the original version; or\n-   d) Limiting the use for publicity purposes of names of licensors\n    or authors of the material; or\n-   e) Declining to grant rights under trademark law for use of some\n    trade names, trademarks, or service marks; or\n-   f) Requiring indemnification of licensors and authors of that\n    material by anyone who conveys the material (or modified versions\n    of it) with contractual assumptions of liability to the recipient,\n    for any liability that these contractual assumptions directly\n    impose on those licensors and authors.\n\nAll other non-permissive additional terms are considered \"further\nrestrictions\" within the meaning of section 10. If the Program as you\nreceived it, or any part of it, contains a notice stating that it is\ngoverned by this License along with a term that is a further\nrestriction, you may remove that term. If a license document contains\na further restriction but permits relicensing or conveying under this\nLicense, you may add to a covered work material governed by the terms\nof that license document, provided that the further restriction does\nnot survive such relicensing or conveying.\n\nIf you add terms to a covered work in accord with this section, you\nmust place, in the relevant source files, a statement of the\nadditional terms that apply to those files, or a notice indicating\nwhere to find the applicable terms.\n\nAdditional terms, permissive or non-permissive, may be stated in the\nform of a separately written license, or stated as exceptions; the\nabove requirements apply either way.","ref":"license.html#7-additional-terms"},{"type":"extras","title":"8. Termination. - LICENSE","doc":"You may not propagate or modify a covered work except as expressly\nprovided under this License. Any attempt otherwise to propagate or\nmodify it is void, and will automatically terminate your rights under\nthis License (including any patent licenses granted under the third\nparagraph of section 11).\n\nHowever, if you cease all violation of this License, then your license\nfrom a particular copyright holder is reinstated (a) provisionally,\nunless and until the copyright holder explicitly and finally\nterminates your license, and (b) permanently, if the copyright holder\nfails to notify you of the violation by some reasonable means prior to\n60 days after the cessation.\n\nMoreover, your license from a particular copyright holder is\nreinstated permanently if the copyright holder notifies you of the\nviolation by some reasonable means, this is the first time you have\nreceived notice of violation of this License (for any work) from that\ncopyright holder, and you cure the violation prior to 30 days after\nyour receipt of the notice.\n\nTermination of your rights under this section does not terminate the\nlicenses of parties who have received copies or rights from you under\nthis License. If your rights have been terminated and not permanently\nreinstated, you do not qualify to receive new licenses for the same\nmaterial under section 10.","ref":"license.html#8-termination"},{"type":"extras","title":"9. Acceptance Not Required for Having Copies. - LICENSE","doc":"You are not required to accept this License in order to receive or run\na copy of the Program. Ancillary propagation of a covered work\noccurring solely as a consequence of using peer-to-peer transmission\nto receive a copy likewise does not require acceptance. However,\nnothing other than this License grants you permission to propagate or\nmodify any covered work. These actions infringe copyright if you do\nnot accept this License. Therefore, by modifying or propagating a\ncovered work, you indicate your acceptance of this License to do so.","ref":"license.html#9-acceptance-not-required-for-having-copies"},{"type":"extras","title":"10. Automatic Licensing of Downstream Recipients. - LICENSE","doc":"Each time you convey a covered work, the recipient automatically\nreceives a license from the original licensors, to run, modify and\npropagate that work, subject to this License. You are not responsible\nfor enforcing compliance by third parties with this License.\n\nAn \"entity transaction\" is a transaction transferring control of an\norganization, or substantially all assets of one, or subdividing an\norganization, or merging organizations. If propagation of a covered\nwork results from an entity transaction, each party to that\ntransaction who receives a copy of the work also receives whatever\nlicenses to the work the party's predecessor in interest had or could\ngive under the previous paragraph, plus a right to possession of the\nCorresponding Source of the work from the predecessor in interest, if\nthe predecessor has it or can get it with reasonable efforts.\n\nYou may not impose any further restrictions on the exercise of the\nrights granted or affirmed under this License. For example, you may\nnot impose a license fee, royalty, or other charge for exercise of\nrights granted under this License, and you may not initiate litigation\n(including a cross-claim or counterclaim in a lawsuit) alleging that\nany patent claim is infringed by making, using, selling, offering for\nsale, or importing the Program or any portion of it.","ref":"license.html#10-automatic-licensing-of-downstream-recipients"},{"type":"extras","title":"11. Patents. - LICENSE","doc":"A \"contributor\" is a copyright holder who authorizes use under this\nLicense of the Program or a work on which the Program is based. The\nwork thus licensed is called the contributor's \"contributor version\".\n\nA contributor's \"essential patent claims\" are all patent claims owned\nor controlled by the contributor, whether already acquired or\nhereafter acquired, that would be infringed by some manner, permitted\nby this License, of making, using, or selling its contributor version,\nbut do not include claims that would be infringed only as a\nconsequence of further modification of the contributor version. For\npurposes of this definition, \"control\" includes the right to grant\npatent sublicenses in a manner consistent with the requirements of\nthis License.\n\nEach contributor grants you a non-exclusive, worldwide, royalty-free\npatent license under the contributor's essential patent claims, to\nmake, use, sell, offer for sale, import and otherwise run, modify and\npropagate the contents of its contributor version.\n\nIn the following three paragraphs, a \"patent license\" is any express\nagreement or commitment, however denominated, not to enforce a patent\n(such as an express permission to practice a patent or covenant not to\nsue for patent infringement). To \"grant\" such a patent license to a\nparty means to make such an agreement or commitment not to enforce a\npatent against the party.\n\nIf you convey a covered work, knowingly relying on a patent license,\nand the Corresponding Source of the work is not available for anyone\nto copy, free of charge and under the terms of this License, through a\npublicly available network server or other readily accessible means,\nthen you must either (1) cause the Corresponding Source to be so\navailable, or (2) arrange to deprive yourself of the benefit of the\npatent license for this particular work, or (3) arrange, in a manner\nconsistent with the requirements of this License, to extend the patent\nlicense to downstream recipients. \"Knowingly relying\" means you have\nactual knowledge that, but for the patent license, your conveying the\ncovered work in a country, or your recipient's use of the covered work\nin a country, would infringe one or more identifiable patents in that\ncountry that you have reason to believe are valid.\n\nIf, pursuant to or in connection with a single transaction or\narrangement, you convey, or propagate by procuring conveyance of, a\ncovered work, and grant a patent license to some of the parties\nreceiving the covered work authorizing them to use, propagate, modify\nor convey a specific copy of the covered work, then the patent license\nyou grant is automatically extended to all recipients of the covered\nwork and works based on it.\n\nA patent license is \"discriminatory\" if it does not include within the\nscope of its coverage, prohibits the exercise of, or is conditioned on\nthe non-exercise of one or more of the rights that are specifically\ngranted under this License. You may not convey a covered work if you\nare a party to an arrangement with a third party that is in the\nbusiness of distributing software, under which you make payment to the\nthird party based on the extent of your activity of conveying the\nwork, and under which the third party grants, to any of the parties\nwho would receive the covered work from you, a discriminatory patent\nlicense (a) in connection with copies of the covered work conveyed by\nyou (or copies made from those copies), or (b) primarily for and in\nconnection with specific products or compilations that contain the\ncovered work, unless you entered into that arrangement, or that patent\nlicense was granted, prior to 28 March 2007.\n\nNothing in this License shall be construed as excluding or limiting\nany implied license or other defenses to infringement that may\notherwise be available to you under applicable patent law.","ref":"license.html#11-patents"},{"type":"extras","title":"12. No Surrender of Others' Freedom. - LICENSE","doc":"If conditions are imposed on you (whether by court order, agreement or\notherwise) that contradict the conditions of this License, they do not\nexcuse you from the conditions of this License. If you cannot convey a\ncovered work so as to satisfy simultaneously your obligations under\nthis License and any other pertinent obligations, then as a\nconsequence you may not convey it at all. For example, if you agree to\nterms that obligate you to collect a royalty for further conveying\nfrom those to whom you convey the Program, the only way you could\nsatisfy both those terms and this License would be to refrain entirely\nfrom conveying the Program.","ref":"license.html#12-no-surrender-of-others-freedom"},{"type":"extras","title":"13. Remote Network Interaction; Use with the GNU General Public License. - LICENSE","doc":"Notwithstanding any other provision of this License, if you modify the\nProgram, your modified version must prominently offer all users\ninteracting with it remotely through a computer network (if your\nversion supports such interaction) an opportunity to receive the\nCorresponding Source of your version by providing access to the\nCorresponding Source from a network server at no charge, through some\nstandard or customary means of facilitating copying of software. This\nCorresponding Source shall include the Corresponding Source for any\nwork covered by version 3 of the GNU General Public License that is\nincorporated pursuant to the following paragraph.\n\nNotwithstanding any other provision of this License, you have\npermission to link or combine any covered work with a work licensed\nunder version 3 of the GNU General Public License into a single\ncombined work, and to convey the resulting work. The terms of this\nLicense will continue to apply to the part which is the covered work,\nbut the work with which it is combined will remain governed by version\n3 of the GNU General Public License.","ref":"license.html#13-remote-network-interaction-use-with-the-gnu-general-public-license"},{"type":"extras","title":"14. Revised Versions of this License. - LICENSE","doc":"The Free Software Foundation may publish revised and/or new versions\nof the GNU Affero General Public License from time to time. Such new\nversions will be similar in spirit to the present version, but may\ndiffer in detail to address new problems or concerns.\n\nEach version is given a distinguishing version number. If the Program\nspecifies that a certain numbered version of the GNU Affero General\nPublic License \"or any later version\" applies to it, you have the\noption of following the terms and conditions either of that numbered\nversion or of any later version published by the Free Software\nFoundation. If the Program does not specify a version number of the\nGNU Affero General Public License, you may choose any version ever\npublished by the Free Software Foundation.\n\nIf the Program specifies that a proxy can decide which future versions\nof the GNU Affero General Public License can be used, that proxy's\npublic statement of acceptance of a version permanently authorizes you\nto choose that version for the Program.\n\nLater license versions may give you additional or different\npermissions. However, no additional obligations are imposed on any\nauthor or copyright holder as a result of your choosing to follow a\nlater version.","ref":"license.html#14-revised-versions-of-this-license"},{"type":"extras","title":"15. Disclaimer of Warranty. - LICENSE","doc":"THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY\nAPPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT\nHOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM \"AS IS\" WITHOUT\nWARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT\nLIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR\nA PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND\nPERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE\nDEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR\nCORRECTION.","ref":"license.html#15-disclaimer-of-warranty"},{"type":"extras","title":"16. Limitation of Liability. - LICENSE","doc":"IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING\nWILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR\nCONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,\nINCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES\nARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT\nNOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR\nLOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM\nTO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR OTHER\nPARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.","ref":"license.html#16-limitation-of-liability"},{"type":"extras","title":"17. Interpretation of Sections 15 and 16. - LICENSE","doc":"If the disclaimer of warranty and limitation of liability provided\nabove cannot be given local legal effect according to their terms,\nreviewing courts shall apply local law that most closely approximates\nan absolute waiver of all civil liability in connection with the\nProgram, unless a warranty or assumption of liability accompanies a\ncopy of the Program in return for a fee.\n\nEND OF TERMS AND CONDITIONS","ref":"license.html#17-interpretation-of-sections-15-and-16"},{"type":"extras","title":"How to Apply These Terms to Your New Programs - LICENSE","doc":"If you develop a new program, and you want it to be of the greatest\npossible use to the public, the best way to achieve this is to make it\nfree software which everyone can redistribute and change under these\nterms.\n\nTo do so, attach the following notices to the program. It is safest to\nattach them to the start of each source file to most effectively state\nthe exclusion of warranty; and each file should have at least the\n\"copyright\" line and a pointer to where the full notice is found.\n\n         \n        Copyright (C)     \n\n        This program is free software: you can redistribute it and/or modify\n        it under the terms of the GNU Affero General Public License as\n        published by the Free Software Foundation, either version 3 of the\n        License, or (at your option) any later version.\n\n        This program is distributed in the hope that it will be useful,\n        but WITHOUT ANY WARRANTY; without even the implied warranty of\n        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n        GNU Affero General Public License for more details.\n\n        You should have received a copy of the GNU Affero General Public License\n        along with this program.  If not, see  .\n\nAlso add information on how to contact you by electronic and paper\nmail.\n\nIf your software can interact with users remotely through a computer\nnetwork, you should also make sure that it provides a way for users to\nget its source. For example, if your program is a web application, its\ninterface could display a \"Source\" link that leads users to an archive\nof the code. There are many ways you could offer source, and different\nsolutions will be better for different programs; see section 13 for\nthe specific requirements.\n\nYou should also get your employer (if you work as a programmer) or\nschool, if any, to sign a \"copyright disclaimer\" for the program, if\nnecessary. For more information on this, and how to apply and follow\nthe GNU AGPL, see  .","ref":"license.html#how-to-apply-these-terms-to-your-new-programs"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}